[![Latest Release](https://img.shields.io/github/v/release/siavash79/aospmods?color=green&include_prereleases&label=Download)](https://github.com/siavash79/AOSPMods/releases/latest)
![Downloads - Stable channel](https://img.shields.io/github/downloads/siavash79/aospmods/total?color=red&label=Downloads%20-%20Stable%20Channel)

[![XDA URL](https://img.shields.io/twitter/url?label=XDA%20Developers&logo=XDA-Developers&style=social&url=https%3A%2F%2Fsh-ort.app%2F1fjst)](https://sh-ort.app/1fjst)
[![Telegram URL](https://img.shields.io/twitter/url?label=Telegram&logo=telegram&style=social&url=https%3A%2F%2Ft.me%2FAOSPMods_Support)](https://t.me/AOSPMods_Support)

![Header Image](https://raw.githubusercontent.com/siavash79/AOSPMods/master/.github/AOSP_Mods_Header.png)

This is a mixed Xposed+Magisk module, which is made to allow customizations that are not originally designed in AOSP (Android Open Source Project).

**(Current) Features:**
- Back gesture customization
- (3-Button navigation) Hold back to kill app
- Hide navigation bar
- Light QS Theme
- Vibrate on QS tile tap
- One-Finger QS panel pulldown
- Customize 4G/LTE icon
- Combined signal Icons
- Double-tap to sleep
- Customization on Battery icon style and size
- Configure build number text in QS footer
- Hide fingerprint circle (Pixel 6)
- Lockscreen shortcut customization
- Configure carrier text in lock screen
- Disable screenshot sound
- Power button long-press to toggle Torch
- Double-tap to wake
- Network Monitor
- Statusbar Height
- Statusbar Padding
- Quick Settings Row & Column numbers
- Quick Settings tiles text size
- Internet / Wifi + Cell Tiles
- Navbar pill thickness
- Navbar pill theme
- Keyboard height
- Icon shapes
- Statusbar Icon styles
- Fonts
- Themed Icons
- SystemUI Tuner
- Brightness Slider in Quick QS
- Battery Bar
- Volume Longpress to skip music
- QS Tiles Styles
- Dark Theme Styles
- Longpress on settings icon (in QS) to launch AOSPMods manager
- Expand/Collapse all notifications
- Tablet taskbar (12.1+)
- Music album art on lockscreen (with blur / grayscale)
- Dual-tone QS header
- Pin code scramble for extra security
- Disable over-scroll effect
- VoLTE Icon
- Double Tap Torch
- Multi-row statusbar
- Editable notification icon limit
- Variable-supported text on lockscreen/AOD
- Easy unlock
- Option to disable fingerprint sensor while the screen is off
- Option to ignore the display cutout
- Option to adjust media volume steps  
- Option to allow upside-down rotation

Of course, this is an ongoing work and the feature list will get longer through time

**Compatibility:**
This module is designed based on AOSP source code. What does it mean? it means that it's expected to work on Roms (Firmwares) which are built based on fairly unmodified Android source code. This means, mainly, Pixel Phones (3, 4, 4a, 5, 5a, 6), and any other Roms that haven't heavily modified the original Android codes. Our feedbacks show that AOSPMods is compatible with Pixel stock Roms and Pixel Experience (normal edition). The mod can also be installed on ArrowOS, Pixel Experience (Plus Edition), ProtonAOSP and LineageOS with *some* broken features.

- Android 12:         Compatible
- Android 12.1 (12L): Compatible
- Android 13:         Compatible
   

**Prerequisites:**
- Compatible Roms (see above)
- Device Rooted by Magisk 24.2+
- LSPosed (Zygisk Version)


**How to install:**
- Install the magisk module
- Reboot (bootloops are not expected)
- You can use AOSPMods app to configure the module

The module is released in 2 flavors, which download and update procedures are different:
- Stable release:  
Manual Install/Update: through repository's Github release page (link below)  
Automated updates: through magisk manager, or through in-app updater  
- Canary release:  
Manual Install/Update: only through repository's Actions page  
Automated install/updates: only through in-app updater - updates will NOT appear in release section, and will NOT count against the module's download count  

*No matter which flavor you're on, you can always switch to the other one with in-app updater

**Credits / Thanks:**
- Android Team
- @topjohnwu for Magisk
- @rovo89 for Xposed
- Team LSPosed
- Team EvolutionX (Specially @kdrag0n). Most of the mods are based on their work
- apsun@github for remote-preferences
- @nijel8 for double-tap to wake

**Translations:**
- @ElTifo Portuguese
- @cracky5322 Chinese Traditional
- @JohnsonRan Chinese Simplified
- @TireX228 Russian
- @ygorigor Romanian
- @krystianokris Polish
- @HofaTheRipper German
- @acuicultor Spanish
- @tomaja18 Spanish
- @n3rd3x3 Spanish
- @TeaqariaWTF Turkish
- @EleoXDA Turkish, German, Russian
- @nmayorga092   Spanish
- @vitalitk Ukrainian
- @siavash79 Persian
- @abalam1980 Dutch
- @trinhloivn Vietnamese

**Brought to you by:**
@siavash79 & @ElTifo
